<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.9) on Wed Oct 28 16:08:51 UTC 2020 -->
<title>mxBase64 (JGraph X 4.2.2 API Specification)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-28">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
<script type="text/javascript" src="../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="mxBase64 (JGraph X 4.2.2 API Specification)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":9,"i1":9,"i2":9,"i3":9,"i4":9,"i5":9,"i6":9,"i7":9,"i8":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxBase64.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">hk.quantr.mxgraph.util</a></div>
<h2 title="Class mxBase64" class="title">Class mxBase64</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>hk.quantr.mxgraph.util.mxBase64</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">mxBase64</span>
extends java.lang.Object</pre>
<div class="block">A very fast and memory efficient class to encode and decode to and from BASE64 in full accordance
 with RFC 2045.<br><br>
 On Windows XP sp1 with 1.4.2_04 and later ;), this encoder and decoder is about 10 times faster
 on small arrays (10 - 1000 bytes) and 2-3 times as fast on larger arrays (10000 - 1000000 bytes)
 compared to <code>sun.misc.Encoder()/Decoder()</code>.<br><br>

 On byte arrays the encoder is about 20% faster than Jakarta Commons Base64 Codec for encode and
 about 50% faster for decoding large arrays. This implementation is about twice as fast on very small
 arrays (&lt 30 bytes). If source/destination is a <code>String</code> this
 version is about three times as fast due to the fact that the Commons Codec result has to be recoded
 to a <code>String</code> from <code>byte[]</code>, which is very expensive.<br><br>

 This encode/decode algorithm doesn't create any temporary arrays as many other codecs do, it only
 allocates the resulting array. This produces less garbage and it is possible to handle arrays twice
 as large as algorithms that create a temporary array. (E.g. Jakarta Commons Codec). It is unknown
 whether Sun's <code>sun.misc.Encoder()/Decoder()</code> produce temporary arrays but since performance
 is quite low it probably does.<br><br>

 The encoder produces the same output as the Sun one except that the Sun's encoder appends
 a trailing line separator if the last character isn't a pad. Unclear why but it only adds to the
 length and is probably a side effect. Both are in conformance with RFC 2045 though.<br>
 Commons codec seem to always att a trailing line separator.<br><br>

 <b>Note!</b>
 The encode/decode method pairs (types) come in three versions with the <b>exact</b> same algorithm and
 thus a lot of code redundancy. This is to not create any temporary arrays for transcoding to/from different
 format types. The methods not used can simply be commented out.<br><br>

 There is also a "fast" version of all decode methods that works the same way as the normal ones, but
 har a few demands on the decoded input. Normally though, these fast verions should be used if the source if
 the input is known and it hasn't bee tampered with.<br><br>

 If you find the code useful or you find a bug, please send me a note at base64 @ miginfocom . com.

 Licence (BSD):
 ==============

 Copyright (c) 2004, Mikael Grev, MiG InfoCom AB. (base64 @ miginfocom . com)
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
 Redistributions of source code must retain the above copyright notice, this list
 of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice, this
 list of conditions and the following disclaimer in the documentation and/or other
 materials provided with the distribution.
 Neither the name of the MiG InfoCom AB nor the names of its contributors may be
 used to endorse or promote products derived from this software without specific
 prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 OF SUCH DAMAGE.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">mxBase64</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decode(byte%5B%5D)">decode</a></span>&#8203;(byte[]&nbsp;sArr)</code></th>
<td class="colLast">
<div class="block">Decodes a BASE64 encoded byte array.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decode(char%5B%5D)">decode</a></span>&#8203;(char[]&nbsp;sArr)</code></th>
<td class="colLast">
<div class="block">Decodes a BASE64 encoded char array.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decode(java.lang.String)">decode</a></span>&#8203;(java.lang.String&nbsp;str)</code></th>
<td class="colLast">
<div class="block">Decodes a BASE64 encoded <code>String</code>.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decodeFast(byte%5B%5D)">decodeFast</a></span>&#8203;(byte[]&nbsp;sArr)</code></th>
<td class="colLast">
<div class="block">Decodes a BASE64 encoded byte array that is known to be resonably well formatted.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decodeFast(char%5B%5D)">decodeFast</a></span>&#8203;(char[]&nbsp;sArr)</code></th>
<td class="colLast">
<div class="block">Decodes a BASE64 encoded char array that is known to be resonably well formatted.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decodeFast(java.lang.String)">decodeFast</a></span>&#8203;(java.lang.String&nbsp;s)</code></th>
<td class="colLast">
<div class="block">Decodes a BASE64 encoded string that is known to be resonably well formatted.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#encodeToByte(byte%5B%5D,boolean)">encodeToByte</a></span>&#8203;(byte[]&nbsp;sArr,
            boolean&nbsp;lineSep)</code></th>
<td class="colLast">
<div class="block">Encodes a raw byte array into a BASE64 <code>byte[]</code> representation i accordance with RFC 2045.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>static char[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#encodeToChar(byte%5B%5D,boolean)">encodeToChar</a></span>&#8203;(byte[]&nbsp;sArr,
            boolean&nbsp;lineSep)</code></th>
<td class="colLast">
<div class="block">Encodes a raw byte array into a BASE64 <code>char[]</code> representation i accordance with RFC 2045.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#encodeToString(byte%5B%5D,boolean)">encodeToString</a></span>&#8203;(byte[]&nbsp;sArr,
              boolean&nbsp;lineSep)</code></th>
<td class="colLast">
<div class="block">Encodes a raw byte array into a BASE64 <code>String</code> representation i accordance with RFC 2045.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>mxBase64</h4>
<pre>public&nbsp;mxBase64()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="encodeToChar(byte[],boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeToChar</h4>
<pre class="methodSignature">public static final&nbsp;char[]&nbsp;encodeToChar&#8203;(byte[]&nbsp;sArr,
                                        boolean&nbsp;lineSep)</pre>
<div class="block">Encodes a raw byte array into a BASE64 <code>char[]</code> representation i accordance with RFC 2045.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The bytes to convert. If <code>null</code> or length 0 an empty array will be returned.</dd>
<dd><code>lineSep</code> - Optional "\r\n" after 76 characters, unless end of file.<br>
 No line separator will be in breach of RFC 2045 which specifies max 76 per line but will be a
 little faster.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A BASE64 encoded array. Never <code>null</code>.</dd>
</dl>
</li>
</ul>
<a id="decode(char[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;decode&#8203;(char[]&nbsp;sArr)</pre>
<div class="block">Decodes a BASE64 encoded char array. All illegal characters will be ignored and can handle both arrays with
 and without line separators.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The source array. <code>null</code> or length 0 will return an empty array.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The decoded array of bytes. May be of length 0. Will be <code>null</code> if the legal characters
 (including '=') isn't divideable by 4.  (I.e. definitely corrupted).</dd>
</dl>
</li>
</ul>
<a id="decodeFast(char[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeFast</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;decodeFast&#8203;(char[]&nbsp;sArr)</pre>
<div class="block">Decodes a BASE64 encoded char array that is known to be resonably well formatted. The method is about twice as
 fast as <a href="#decode(char%5B%5D)"><code>decode(char[])</code></a>. The preconditions are:<br>
 + The array must have a line length of 76 chars OR no line separators at all (one line).<br>
 + Line separator must be "\r\n", as specified in RFC 2045
 + The array must not contain illegal characters within the encoded string<br>
 + The array CAN have illegal characters at the beginning and end, those will be dealt with appropriately.<br></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The source array. Length 0 will return an empty array. <code>null</code> will throw an exception.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The decoded array of bytes. May be of length 0.</dd>
</dl>
</li>
</ul>
<a id="encodeToByte(byte[],boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeToByte</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;encodeToByte&#8203;(byte[]&nbsp;sArr,
                                        boolean&nbsp;lineSep)</pre>
<div class="block">Encodes a raw byte array into a BASE64 <code>byte[]</code> representation i accordance with RFC 2045.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The bytes to convert. If <code>null</code> or length 0 an empty array will be returned.</dd>
<dd><code>lineSep</code> - Optional "\r\n" after 76 characters, unless end of file.<br>
 No line separator will be in breach of RFC 2045 which specifies max 76 per line but will be a
 little faster.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A BASE64 encoded array. Never <code>null</code>.</dd>
</dl>
</li>
</ul>
<a id="decode(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;decode&#8203;(byte[]&nbsp;sArr)</pre>
<div class="block">Decodes a BASE64 encoded byte array. All illegal characters will be ignored and can handle both arrays with
 and without line separators.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The source array. Length 0 will return an empty array. <code>null</code> will throw an exception.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The decoded array of bytes. May be of length 0. Will be <code>null</code> if the legal characters
 (including '=') isn't divideable by 4. (I.e. definitely corrupted).</dd>
</dl>
</li>
</ul>
<a id="decodeFast(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeFast</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;decodeFast&#8203;(byte[]&nbsp;sArr)</pre>
<div class="block">Decodes a BASE64 encoded byte array that is known to be resonably well formatted. The method is about twice as
 fast as <a href="#decode(byte%5B%5D)"><code>decode(byte[])</code></a>. The preconditions are:<br>
 + The array must have a line length of 76 chars OR no line separators at all (one line).<br>
 + Line separator must be "\r\n", as specified in RFC 2045
 + The array must not contain illegal characters within the encoded string<br>
 + The array CAN have illegal characters at the beginning and end, those will be dealt with appropriately.<br></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The source array. Length 0 will return an empty array. <code>null</code> will throw an exception.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The decoded array of bytes. May be of length 0.</dd>
</dl>
</li>
</ul>
<a id="encodeToString(byte[],boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeToString</h4>
<pre class="methodSignature">public static final&nbsp;java.lang.String&nbsp;encodeToString&#8203;(byte[]&nbsp;sArr,
                                                    boolean&nbsp;lineSep)</pre>
<div class="block">Encodes a raw byte array into a BASE64 <code>String</code> representation i accordance with RFC 2045.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sArr</code> - The bytes to convert. If <code>null</code> or length 0 an empty array will be returned.</dd>
<dd><code>lineSep</code> - Optional "\r\n" after 76 characters, unless end of file.<br>
 No line separator will be in breach of RFC 2045 which specifies max 76 per line but will be a
 little faster.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A BASE64 encoded array. Never <code>null</code>.</dd>
</dl>
</li>
</ul>
<a id="decode(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;decode&#8203;(java.lang.String&nbsp;str)</pre>
<div class="block">Decodes a BASE64 encoded <code>String</code>. All illegal characters will be ignored and can handle both strings with
 and without line separators.<br>
 <b>Note!</b> It can be up to about 2x the speed to call <code>decode(str.toCharArray())</code> instead. That
 will create a temporary array though. This version will use <code>str.charAt(i)</code> to iterate the string.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>str</code> - The source string. <code>null</code> or length 0 will return an empty array.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The decoded array of bytes. May be of length 0. Will be <code>null</code> if the legal characters
 (including '=') isn't divideable by 4.  (I.e. definitely corrupted).</dd>
</dl>
</li>
</ul>
<a id="decodeFast(java.lang.String)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>decodeFast</h4>
<pre class="methodSignature">public static final&nbsp;byte[]&nbsp;decodeFast&#8203;(java.lang.String&nbsp;s)</pre>
<div class="block">Decodes a BASE64 encoded string that is known to be resonably well formatted. The method is about twice as
 fast as <a href="#decode(java.lang.String)"><code>decode(String)</code></a>. The preconditions are:<br>
 + The array must have a line length of 76 chars OR no line separators at all (one line).<br>
 + Line separator must be "\r\n", as specified in RFC 2045
 + The array must not contain illegal characters within the encoded string<br>
 + The array CAN have illegal characters at the beginning and end, those will be dealt with appropriately.<br></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - The source string. Length 0 will return an empty array. <code>null</code> will throw an exception.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The decoded array of bytes. May be of length 0.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxBase64.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small><font size=1>Copyright (c) 2010 <a href="http://www.mxgraph.com/"
				target="_blank">Gaudenz Alder</a>. All rights reserved.</font></small></p>
</footer>
</body>
</html>
